<?

 /******************************************************************************************
 * Filename: achievements.php
 *
 * This file is part of the Achievements JAS plugin.
 * Copyright 2003-2017 by Matthijs Schuurman
 *
 * The Achievements JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/achievements/
 ******************************************************************************************/

 class Plugin_achievements extends Base_Plugin
 {
  function main($type=false)
  {
   $this->type=false;

   if($type=="achieved")
    $this->type=$type;

   return true;
  }

  function output()
  {
   global $_path, $_config;

   $d=Data::cache("achievements_achievements", "view", "all");

   $d->clearValues();

   if($this->type!="achieved")
    $d->setValue("disabled", false);

   $d->setShowFields("name", "title", "progress", "description", "badge");

   if(!$d->get()||!$d->vmax)
   {
    $this->e->add($d->e);
    return false;
   }

   $r="";
   while($d->next())
   {
    $class="achievement";
    if($d->v["progress"]===true||$d->v["progress"]>=1)
    {
     $class.=" p100";
     $progress=$this->plugin->l->t("Achieved");
    }
    else
    {
     if($this->type=="achieved")
      continue; //skip not yet achieved

     if(!$d->v["progress"])
     {
      $class.=" p0";
      $progress="";
     }
     else
     {
      $class.=" p".(floor($d->v["progress"]*10)*10);
      $progress=floor($d->v["progress"]*100)."%";
     }
    }

    $r.="<a href=\"".$_path["HTML"]["prefix"]."achievements/#".str_replace(" ", "_", $d->v["name"])."\" class=\"".$class."\" id=\"".str_replace(" ", "_", $d->v["name"])."\">\n";
    $r.=" <div class=\"badge\">".($d->v["badge"]?"<img src=\"".$_path["HTML"]["prefix"].$_path["images"]."achievements_achievements/badge/".$d->v["nr"]."/progress/\" alt=\"".$d->v["title"]." badge\"/>":"")."</div>\n";
    $r.=" <div class=\"title\">".$d->v["title"]."</div>\n";
    $r.=" <div class=\"description\">".$d->v["description"]."</div>\n";
    $r.=" <div class=\"progress\">".$progress."</div>\n";
    $r.="</a>\n";
   }

   return $r;
  }
 }

?>
